jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | |
| 44 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 45 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 46 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 47 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 48 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 49 | export USE_JACK="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
| 76 | # If the tree is compiled with Jack, build test with Jack by default. |
| 77 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 78 | USE_JACK="true" |
| 79 | fi |
| 80 | |
| 81 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 82 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 83 | export ANDROID_BUILD_TOP=$oldwd |
| 84 | fi |
| 85 | |
| 86 | # If JACK_VM_COMMAND is not set, assume it launches the prebuilt jack-launcher. |
| 87 | if [ -z "$JACK_VM_COMMAND" ]; then |
| 88 | if [ ! -z "$TMPDIR" ]; then |
| 89 | jack_temp_dir="-Djava.io.tmpdir=$TMPDIR" |
| 90 | fi |
| 91 | export JACK_VM_COMMAND="java -Dfile.encoding=UTF-8 -Xms2560m -XX:+TieredCompilation $jack_temp_dir -jar $ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack-launcher.jar" |
| 92 | fi |
| 93 | |
| 94 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 95 | if [ -z "$JACK_CLASSPATH" ]; then |
| 96 | export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
| 97 | fi |
| 98 | |
| 99 | # If JACK_JAR is not set, assume it is located in the prebuilts directory. |
| 100 | if [ -z "$JACK_JAR" ]; then |
| 101 | export JACK_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack.jar" |
| 102 | fi |
| 103 | |
| 104 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 105 | if [ -z "$JILL_JAR" ]; then |
| 106 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 107 | fi |
| 108 | |
| 109 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 110 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 111 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | info="info.txt" |
| 113 | build="build" |
| 114 | run="run" |
| 115 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 116 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 117 | output="output.txt" |
| 118 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 119 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 120 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 121 | lib="libartd.so" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 123 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 124 | |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 125 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 126 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 127 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 128 | dev_mode="no" |
| 129 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 130 | debug_mode="no" |
| 131 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 132 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 133 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 134 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 135 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 136 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 137 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 138 | basic_verify="false" |
| 139 | gc_verify="false" |
| 140 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 141 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 142 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 143 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 144 | have_dex2oat="yes" |
| 145 | have_patchoat="yes" |
| 146 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 147 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 148 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 149 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 150 | |
| 151 | while true; do |
| 152 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 153 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 154 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 155 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 156 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 157 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 158 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 159 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 160 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 161 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 162 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 163 | run_args="${run_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 164 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 165 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 166 | lib="libart.so" |
| 167 | shift |
| 168 | elif [ "x$1" = "x--dalvik" ]; then |
| 169 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 170 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 171 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 172 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 173 | have_dex2oat="no" |
| 174 | shift |
| 175 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 176 | have_patchoat="no" |
| 177 | shift |
| 178 | elif [ "x$1" = "x--no-image" ]; then |
| 179 | have_image="no" |
| 180 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 181 | elif [ "x$1" = "x--pic-image" ]; then |
| 182 | pic_image_suffix="-pic" |
| 183 | shift |
| 184 | elif [ "x$1" = "x--pic-test" ]; then |
| 185 | run_args="${run_args} --pic-test" |
| 186 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 187 | elif [ "x$1" = "x--relocate" ]; then |
| 188 | relocate="yes" |
| 189 | shift |
| 190 | elif [ "x$1" = "x--no-relocate" ]; then |
| 191 | relocate="no" |
| 192 | shift |
| 193 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 194 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 195 | prebuild_mode="yes" |
| 196 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 197 | elif [ "x$1" = "x--debuggable" ]; then |
| 198 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 199 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 200 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 201 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 202 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 203 | prebuild_mode="no" |
| 204 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 205 | elif [ "x$1" = "x--gcverify" ]; then |
| 206 | basic_verify="true" |
| 207 | gc_verify="true" |
| 208 | shift |
| 209 | elif [ "x$1" = "x--gcstress" ]; then |
| 210 | basic_verify="true" |
| 211 | gc_stress="true" |
| 212 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 213 | elif [ "x$1" = "x--image" ]; then |
| 214 | shift |
| 215 | image="$1" |
| 216 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 217 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 218 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 219 | shift |
| 220 | option="$1" |
| 221 | run_args="${run_args} -Xcompiler-option $option" |
| 222 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 223 | elif [ "x$1" = "x--runtime-option" ]; then |
| 224 | shift |
| 225 | option="$1" |
| 226 | run_args="${run_args} --runtime-option $option" |
| 227 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 228 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 229 | shift |
| 230 | gdb_arg="$1" |
| 231 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 232 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 233 | elif [ "x$1" = "x--debug" ]; then |
| 234 | run_args="${run_args} --debug" |
| 235 | shift |
| 236 | elif [ "x$1" = "x--gdb" ]; then |
| 237 | run_args="${run_args} --gdb" |
| 238 | dev_mode="yes" |
| 239 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 240 | elif [ "x$1" = "x--strace" ]; then |
| 241 | strace="yes" |
| 242 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 243 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 244 | elif [ "x$1" = "x--zygote" ]; then |
| 245 | run_args="${run_args} --zygote" |
| 246 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 247 | elif [ "x$1" = "x--interpreter" ]; then |
| 248 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 249 | image_suffix="-interpreter" |
| 250 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 251 | elif [ "x$1" = "x--jit" ]; then |
| 252 | run_args="${run_args} --jit" |
Mathieu Chartier | e2a12c0 | 2015-02-27 13:21:15 -0800 | [diff] [blame] | 253 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 254 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 255 | elif [ "x$1" = "x--optimizing" ]; then |
| 256 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 257 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 258 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 259 | elif [ "x$1" = "x--quick" ]; then |
| 260 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 261 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 262 | elif [ "x$1" = "x--no-verify" ]; then |
| 263 | run_args="${run_args} --no-verify" |
| 264 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 265 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
| 266 | run_args="${run_args} --verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame^] | 267 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 268 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 269 | elif [ "x$1" = "x--no-optimize" ]; then |
| 270 | run_args="${run_args} --no-optimize" |
| 271 | shift |
| 272 | elif [ "x$1" = "x--no-precise" ]; then |
| 273 | run_args="${run_args} --no-precise" |
| 274 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 275 | elif [ "x$1" = "x--invoke-with" ]; then |
| 276 | shift |
| 277 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 278 | if [ "x$what" = "x" ]; then |
| 279 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 280 | usage="yes" |
| 281 | break |
| 282 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 283 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 284 | shift |
| 285 | elif [ "x$1" = "x--dev" ]; then |
| 286 | run_args="${run_args} --dev" |
| 287 | dev_mode="yes" |
| 288 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 289 | elif [ "x$1" = "x--build-only" ]; then |
| 290 | build_only="yes" |
| 291 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 292 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 293 | USE_JACK="false" |
| 294 | shift |
| 295 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 296 | USE_JACK="true" |
| 297 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 298 | elif [ "x$1" = "x--output-path" ]; then |
| 299 | shift |
| 300 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 301 | if [ "x$tmp_dir" = "x" ]; then |
| 302 | echo "$0 missing argument to --output-path" 1>&2 |
| 303 | usage="yes" |
| 304 | break |
| 305 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 306 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 307 | elif [ "x$1" = "x--android-root" ]; then |
| 308 | shift |
| 309 | if [ "x$1" = "x" ]; then |
| 310 | echo "$0 missing argument to --android-root" 1>&2 |
| 311 | usage="yes" |
| 312 | break |
| 313 | fi |
| 314 | android_root="$1" |
| 315 | run_args="${run_args} --android-root $1" |
| 316 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 317 | elif [ "x$1" = "x--update" ]; then |
| 318 | update_mode="yes" |
| 319 | shift |
| 320 | elif [ "x$1" = "x--help" ]; then |
| 321 | usage="yes" |
| 322 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 323 | elif [ "x$1" = "x--64" ]; then |
| 324 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 325 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 326 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 327 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 328 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 329 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 330 | elif [ "x$1" = "x--stream" ]; then |
| 331 | trace_stream="true" |
| 332 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 333 | elif [ "x$1" = "x--always-clean" ]; then |
| 334 | always_clean="yes" |
| 335 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 336 | elif [ "x$1" = "x--never-clean" ]; then |
| 337 | never_clean="yes" |
| 338 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 339 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 340 | run_args="${run_args} --dex2oat-swap" |
| 341 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 342 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 343 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 344 | usage="yes" |
| 345 | break |
| 346 | else |
| 347 | break |
| 348 | fi |
| 349 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 350 | |
| 351 | # tmp_dir may be relative, resolve. |
| 352 | # |
| 353 | # Cannot use realpath, as it does not exist on Mac. |
| 354 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 355 | # Cannot use readlink -m, as it does not exist on Mac. |
| 356 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 357 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 358 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 359 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 360 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 361 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 362 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 363 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 364 | fi |
| 365 | if [ "$gc_verify" = "true" ]; then |
| 366 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 367 | fi |
| 368 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 369 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 370 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 371 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 372 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 373 | if [ "$trace_stream" = "true" ]; then |
| 374 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 375 | # the ability to analyze the file and just write to /dev/null. |
| 376 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 377 | # Enable streaming mode. |
| 378 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 379 | else |
| 380 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 381 | fi |
| 382 | elif [ "$trace_stream" = "true" ]; then |
| 383 | echo "Cannot use --stream without --trace." |
| 384 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 385 | fi |
| 386 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 387 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 388 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 389 | function guess_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 390 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 391 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 392 | if [ "x${suffix64}" = "x64" ]; then |
| 393 | target_arch_name=${grep64bit} |
| 394 | else |
| 395 | target_arch_name=${grep32bit} |
| 396 | fi |
| 397 | } |
| 398 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 399 | if [ "$target_mode" = "no" ]; then |
| 400 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 401 | if [ "$prebuild_mode" = "yes" ]; then |
| 402 | echo "--prebuild with --jvm is unsupported"; |
| 403 | exit 1; |
| 404 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 405 | fi |
| 406 | fi |
| 407 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 408 | if [ "$have_patchoat" = "no" ]; then |
| 409 | run_args="${run_args} --no-patchoat" |
| 410 | fi |
| 411 | |
| 412 | if [ "$have_dex2oat" = "no" ]; then |
| 413 | run_args="${run_args} --no-dex2oat" |
| 414 | fi |
| 415 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 416 | if [ ! "$runtime" = "jvm" ]; then |
| 417 | run_args="${run_args} --lib $lib" |
| 418 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 419 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 420 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 421 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 422 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 423 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 424 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 425 | else |
| 426 | true # defaults to using target BOOTCLASSPATH |
| 427 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 428 | elif [ "$runtime" = "art" ]; then |
| 429 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 430 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 431 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 432 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 433 | fi |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 434 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 435 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 436 | else |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 437 | guess_arch_name |
| 438 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 439 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 440 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 441 | if [ "$relocate" = "yes" ]; then |
| 442 | run_args="${run_args} --relocate" |
| 443 | else |
| 444 | run_args="${run_args} --no-relocate" |
| 445 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 446 | elif [ "$runtime" = "jvm" ]; then |
| 447 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 448 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 449 | fi |
| 450 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 451 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 452 | if [ "$runtime" != "art" ]; then |
| 453 | echo "--no-image is only supported on the art runtime" |
| 454 | exit 1 |
| 455 | fi |
| 456 | if [ "$target_mode" = "no" ]; then |
| 457 | framework="${ANDROID_HOST_OUT}/framework" |
| 458 | bpath_suffix="-hostdex" |
| 459 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 460 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 461 | bpath_suffix="" |
| 462 | fi |
| 463 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 464 | # fail since these jar files will be stripped. |
| 465 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 466 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 467 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 468 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 469 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 470 | # Pass down the bootclasspath |
| 471 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 472 | run_args="${run_args} --no-image" |
| 473 | fi |
| 474 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 475 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 476 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 477 | usage="yes" |
| 478 | fi |
| 479 | |
| 480 | if [ "$usage" = "no" ]; then |
| 481 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 482 | test_dir=`basename "$oldwd"` |
| 483 | else |
| 484 | test_dir="$1" |
| 485 | fi |
| 486 | |
| 487 | if [ '!' -d "$test_dir" ]; then |
| 488 | td2=`echo ${test_dir}-*` |
| 489 | if [ '!' -d "$td2" ]; then |
| 490 | echo "${test_dir}: no such test directory" 1>&2 |
| 491 | usage="yes" |
| 492 | fi |
| 493 | test_dir="$td2" |
| 494 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 495 | # Shift to get rid of the test name argument. The rest of the arguments |
| 496 | # will get passed to the test run. |
| 497 | shift |
| 498 | fi |
| 499 | |
| 500 | if [ "$usage" = "yes" ]; then |
| 501 | prog=`basename $prog` |
| 502 | ( |
| 503 | echo "usage:" |
| 504 | echo " $prog --help Print this message." |
| 505 | echo " $prog [options] [test-name] Run test normally." |
| 506 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 507 | "(dumps to stdout)." |
| 508 | echo " $prog --update [options] [test-name] Update mode" \ |
| 509 | "(replaces expected.txt)." |
| 510 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 511 | "current directory." |
| 512 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 513 | echo " -O Run non-debug rather than debug build (off by default)." |
| 514 | echo " -Xcompiler-option Pass an option to the compiler." |
| 515 | echo " --runtime-option Pass an option to the runtime." |
| 516 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 517 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 518 | echo " --gdb Run under gdb; incompatible with some tests." |
| 519 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 520 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 521 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 522 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 523 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 524 | echo " --optimizing Enable optimizing compiler (default)." |
| 525 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 526 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 527 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 528 | echo " Verification is enabled if neither --no-verify" |
| 529 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 530 | echo " --no-optimize Turn off optimization (on by default)." |
| 531 | echo " --no-precise Turn off precise GC (on by default)." |
| 532 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 533 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 534 | echo " other runtime options are ignored." |
| 535 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 536 | echo " --no-patchoat Run as though patchoat was failing." |
| 537 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 538 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 539 | echo " the test." |
| 540 | echo " --relocate Force the use of relocating in the test, making" |
| 541 | echo " the image and oat files be relocated to a random" |
| 542 | echo " address before running. (default)" |
| 543 | echo " --no-relocate Force the use of no relocating in the test" |
| 544 | echo " --host Use the host-mode virtual machine." |
| 545 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 546 | echo " --dalvik Use Dalvik (off by default)." |
| 547 | echo " --jvm Use a host-local RI virtual machine." |
| 548 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 549 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 550 | echo " --64 Run the test in 64-bit mode" |
| 551 | echo " --trace Run with method tracing" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 552 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 553 | echo " --gcstress Run with gc stress testing" |
| 554 | echo " --gcverify Run with gc verification" |
| 555 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 556 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 557 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 558 | echo " --dex2oat-swap Use a dex2oat swap file." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 559 | ) 1>&2 |
| 560 | exit 1 |
| 561 | fi |
| 562 | |
| 563 | cd "$test_dir" |
| 564 | test_dir=`pwd` |
| 565 | |
| 566 | td_info="${test_dir}/${info}" |
| 567 | td_expected="${test_dir}/${expected}" |
| 568 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 569 | if [ ! -r $td_info ]; then |
| 570 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 571 | exit 1 |
| 572 | fi |
| 573 | |
| 574 | if [ ! -r $td_expected ]; then |
| 575 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 576 | exit 1 |
| 577 | fi |
| 578 | |
| 579 | # copy the test to a temp dir and run it |
| 580 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 581 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 582 | |
| 583 | rm -rf "$tmp_dir" |
| 584 | cp -Rp "$test_dir" "$tmp_dir" |
| 585 | cd "$tmp_dir" |
| 586 | |
| 587 | if [ '!' -r "$build" ]; then |
| 588 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 589 | else |
| 590 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 591 | fi |
| 592 | |
| 593 | if [ '!' -r "$run" ]; then |
| 594 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 595 | else |
| 596 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 597 | fi |
| 598 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 599 | if [ '!' -r "$check_cmd" ]; then |
| 600 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 601 | else |
| 602 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 603 | fi |
| 604 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 605 | chmod 755 "$build" |
| 606 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 607 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 608 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 609 | export TEST_NAME=`basename ${test_dir}` |
| 610 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 611 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 612 | # Checker when compiled with Optimizing on host. |
| 613 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 614 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 615 | # better resembles the Java source. We always build the DEX the same way, even |
| 616 | # if Checker is not invoked and the test only runs the program. |
| 617 | build_args="${build_args} --dx-option --no-optimize" |
| 618 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 619 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 620 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 621 | USE_JACK="false" |
| 622 | |
Nicolas Geoffray | e730729 | 2015-03-17 18:12:06 +0000 | [diff] [blame] | 623 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" -a "$debuggable" = "no" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 624 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 625 | # patchoat are available. Disable Checker otherwise (b/22552692). |
| 626 | if [ "$prebuild_mode" = "yes" ] || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
| 627 | run_checker="yes" |
| 628 | run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \ |
| 629 | -Xcompiler-option -j1" |
| 630 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 631 | fi |
| 632 | fi |
| 633 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 634 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 635 | build_file_size_limit=2048 |
| 636 | run_file_size_limit=2048 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 637 | if echo "$test_dir" | grep 089; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 638 | build_file_size_limit=5120 |
| 639 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 640 | elif echo "$test_dir" | grep 083; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 641 | build_file_size_limit=5120 |
| 642 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 643 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 644 | if [ ${USE_JACK} = "false" ]; then |
| 645 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 646 | if ! ulimit -S "$build_file_size_limit"; then |
| 647 | echo "ulimit file size setting failed" |
| 648 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 649 | fi |
| 650 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 651 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 652 | good_build="yes" |
| 653 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 654 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 655 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 656 | build_exit="$?" |
| 657 | echo "build exit status: $build_exit" 1>&2 |
| 658 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 659 | if ! ulimit -S "$run_file_size_limit"; then |
| 660 | echo "ulimit file size setting failed" |
| 661 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 662 | echo "${test_dir}: running..." 1>&2 |
| 663 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 664 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 665 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 666 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 667 | if [ "$run_checker" = "yes" ]; then |
| 668 | "$checker" "$cfg_output" "$tmp_dir" 2>&1 |
| 669 | checker_exit="$?" |
| 670 | if [ "$checker_exit" = "0" ]; then |
| 671 | good="yes" |
| 672 | fi |
| 673 | echo "checker exit status: $checker_exit" 1>&2 |
| 674 | else |
| 675 | good="yes" |
| 676 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 677 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 678 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 679 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 680 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 681 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 682 | build_exit="$?" |
| 683 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 684 | if ! ulimit -S "$run_file_size_limit"; then |
| 685 | echo "ulimit file size setting failed" |
| 686 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 687 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 688 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 689 | if [ "$run_checker" = "yes" ]; then |
| 690 | "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
| 691 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 692 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 693 | good="yes" |
| 694 | else |
| 695 | cat "$build_output" 1>&2 |
| 696 | echo "build exit status: $build_exit" 1>&2 |
| 697 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 698 | elif [ "$build_only" = "yes" ]; then |
| 699 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 700 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 701 | build_exit="$?" |
| 702 | if [ "$build_exit" '!=' '0' ]; then |
| 703 | cp "$build_output" "$output" |
| 704 | echo "build exit status: $build_exit" >>"$output" |
| 705 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 706 | if [ "$?" '!=' "0" ]; then |
| 707 | good="no" |
| 708 | echo "BUILD FAILED For ${TEST_NAME}" |
| 709 | fi |
| 710 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 711 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 712 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 713 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 714 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 715 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 716 | build_exit="$?" |
| 717 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 718 | if ! ulimit -S "$run_file_size_limit"; then |
| 719 | echo "ulimit file size setting failed" |
| 720 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 721 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 722 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 723 | run_exit="$?" |
| 724 | if [ "$run_exit" != "0" ]; then |
| 725 | echo "run exit status: $run_exit" 1>&2 |
| 726 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 727 | elif [ "$run_checker" = "yes" ]; then |
| 728 | "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
| 729 | checker_exit="$?" |
| 730 | if [ "$checker_exit" != "0" ]; then |
| 731 | echo "checker exit status: $checker_exit" 1>&2 |
| 732 | good_run="no" |
| 733 | else |
| 734 | good_run="yes" |
| 735 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 736 | else |
| 737 | good_run="yes" |
| 738 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 739 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 740 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 741 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 742 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 743 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 744 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 745 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 746 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 747 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 748 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 749 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 750 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 751 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 752 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 753 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 754 | # output == expected |
| 755 | good="yes" |
| 756 | echo "${test_dir}: succeeded!" 1>&2 |
| 757 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 758 | fi |
| 759 | fi |
| 760 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 761 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 762 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 763 | echo "${test_dir}: FAILED!" |
| 764 | echo ' ' |
| 765 | echo '#################### info' |
| 766 | cat "${td_info}" | sed 's/^/# /g' |
| 767 | echo '#################### diffs' |
Ian Rogers | 75deec0 | 2014-11-23 20:07:39 -0800 | [diff] [blame] | 768 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 769 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 770 | if [ "$strace" = "yes" ]; then |
| 771 | echo '#################### strace output' |
| 772 | tail -n 2000 "$tmp_dir/$strace_output" |
| 773 | echo '####################' |
| 774 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 775 | echo ' ' |
| 776 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 777 | |
| 778 | ) 1>&2 |
| 779 | |
| 780 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 781 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 782 | cd "$oldwd" |
| 783 | rm -rf "$tmp_dir" |
| 784 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 785 | adb shell rm -rf $DEX_LOCATION |
| 786 | fi |
| 787 | if [ "$good" = "yes" ]; then |
| 788 | exit 0 |
| 789 | fi |
| 790 | fi |
| 791 | |
| 792 | |
| 793 | ( |
| 794 | if [ "$always_clean" = "yes" ]; then |
| 795 | echo "${TEST_NAME} files deleted from host " |
| 796 | if [ "$target_mode" == "yes" ]; then |
| 797 | echo "and from target" |
| 798 | fi |
| 799 | else |
| 800 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 801 | if [ "$target_mode" == "yes" ]; then |
| 802 | echo "and in ${DEX_LOCATION} on target" |
| 803 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 804 | fi |
| 805 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 806 | ) 1>&2 |
| 807 | |
| 808 | exit 1 |